/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 27/12/2009
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 1.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/
#include <mega16.h>
#include <stdio.h>
#include <delay.h>
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>
unsigned char str[40];
long int y,rpm,v,j,p,b,z,key=255,q=0,ki=4,kd=2,kp=4,pwm,scal=450,u,irpm=3500,CurSpd;
unsigned char code[4][4]={{0,4,8,12},{1,5,9,13},{2,6,10,14},{3,7,11,15}};
/////////////////////////////////////////
void PID(void);
// Timer 0 output compare interrupt service routine
/////////////////////////////////////////////////////////cunter  timer 000
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
y++;
}

// Timer 1 overflow interrupt service routine
/////////////////////////////////////////////////////////pwm timer  1111
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
 TCNT1H=0x00;
 TCNT1L=0x82;
 }
////////////////////////////////////////////////////////////timer 2222
// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{ 
    static unsigned char rr;
    rr=TCNT0;
    TCNT2=0x0A;
    TCCR0=0x00; 
    rpm=(y*100+TCNT0)*24/10;
    y=0;      
    TCNT0=0;       
    rr=0;  
    TCCR0=0x0E;
    PID(); 
}

/////////////////////////////////////////////pid

void PID(void)
{
        static long jahat=0,e0=0,e1=0,e2=0,e3=0;
         
        long k=0; 
        CurSpd =rpm;
        e3=e2;
        e2=e1;
        e1=e0;
        e0 =irpm-CurSpd; 
        k=(kp*(e0+e1)+ki*(e0-e1)+(3*(e0-e2)+(e1-e3)*kd))/scal;
      
        pwm = pwm + k;
    
                  
        if(pwm>131)
        {
            if(pwm>254)pwm=253;
            OCR1AL=pwm;
        }
        if(pwm<131)
        { 
              
           jahat=~jahat;
            if(jahat==0)PORTD=0X09;
            if(jahat==1)PORTD=0X06;
            OCR1AL=262-pwm;
        }
       
}

 ///////////////////////////////////////////////key pad///////////////////////

 unsigned char scan_key(void)
{
unsigned char i,data,num_key,temp,p;
num_key=0xff;
temp=0x70;
for(i=0;i<4;i++)
{
PORTA=temp;
delay_ms(2);
data=PINA&0X0F;
delay_ms(10);
data=PINA&0X0F;
if(data==0x07)num_key=code[0][i];
if(data==0x0b)num_key=code[1][i];
if(data==0x0d)num_key=code[2][i];
if(data==0x0e)num_key=code[3][i];
temp=((temp>>1)|0x80)&0xf0;
}
return num_key;
} 
//////////////////////
 void keyin (void)
 {
   if(z>=0 && z<=9)
        {
               delay_ms(100);       
                b=z+b*10; 
           
         }
 }
/////////////
void main(void)
{ 

// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0xf0;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T 
PORTB=0xF0;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x09;
DDRD=0xEF;

// Timer/Counter 0 initialization
// Clock source: T0 pin Rising Edge
// Mode: CTC top=OCR0
// OC0 output: Disconnected
TCCR0=0x0F;
TCNT0=0x00;
OCR0=0x63;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000.000 kHz
// Mode: Fast PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
/*TCCR1A=0x81;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x37;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x3b;
OCR1BH=0x00;
OCR1BL=0x00;*/ 
///////////////////    
TCCR1A=0x81;
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x82;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0xC8;
OCR1BH=0x00;
OCR1BL=0x00; 
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 0.977 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x07;
TCNT2=0x0A;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: On
// INT2 Mode: Rising Edge
//GICR|=0x20;
MCUCR=0x00;
MCUCSR=0x00;
//GIFR=0x20;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x46;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")
PORTD=0X09;
while (1)
      {  
    
     key=scan_key();
     
     switch(key)
       { 
          case 0 :z=16;
          break;
          case 1 :z=15;
          break;
          case 2 : z=12;
          break;
          case 3 : z=14;
          break;
          case 4 : z=13;
          break;
          case 5 :z=9;
          break;
          case 6 : z=6;
          break;
          case 7 : z=3;
          break;
          case 8 : z=0;
          break;
          case 9 : z=8;
          break;
          case 10 : z=5;
          break;
          case 11 : z=2;
          break;
          case 12 : z=11;
          break;
          case 13 : z=7;
          break;
          case 14 :z=4;
          break;
          case 15 :z=1;
          break;
      }  
      
      delay_ms(5);
     if(key!=0xff)
    { 
       delay_ms(200);
       if(key!=0xff)keyin(); 
     } 
        
    /////////////// /////////////////////////////
     if(key==4)q++;
     if(q==4)q=0;
     if(q==0)
     { 
       lcd_gotoxy(0,0);
       sprintf(str,"pwm=%03d         rpm=%04d     ",OCR1AL,rpm,);
       lcd_puts(str);
     } 
     /////////
      if(q==1)
     { 
        if(key==2) PORTD=0X09;
        if(key==1)PORTD=0X06;
        if(key==3)PORTD=0X05;
        if(PORTD==0X09)
        {
            lcd_gotoxy(0,0);            
            lcd_putsf("chap             ");
        }  
                      
         if(PORTD==0X06)
         {
            lcd_gotoxy(0,0);
            lcd_putsf("rast              ");
         }  
         if(PORTD==0X05)
         {
            lcd_gotoxy(0,0);        
            lcd_putsf("stop               ");
         }                    
         
          if(PINB.1==1)
          {
             lcd_gotoxy(0,1);
             lcd_putsf("ENCOD=rast         ");
          }                    
     
           if(PINB.1==0)
          {
              lcd_gotoxy(0,1);
              lcd_putsf("ENCOD=chap          ");
          }                    
      }
    /////////////////////////
     if(q==2)
     { 
         static unsigned char c=0;
         if(c==0 && z>=0 && z<=9)scal=b;
      //////////////////////////////////////
       if(c==1)
       { 
        if(key==1)
     {  
        delay_ms(10);
        if(key==1) kp=kp+1;
       
     }  
    ///////// 
     if(key==2)
     {  
        delay_ms(10);
        if(key==2) kp=kp-1;
       
     }   
                  
         if( z>=0 && z<=9) kp=b;
           
     }           
       
    //////////////////////////         //////////////
       if(c==2)
       {
         if(key==1)
     {  
        delay_ms(10);
        if(key==1) ki=ki+1;
        
     }  
    ////////
     if(key==2)
     {  
        delay_ms(10);
        if(key==2)ki=ki-1;
        
       }
       
       if(& z>=0 && z<=9)ki=b;
       }
      ////////////////////////////////////////////////////
      
       if(c==3)
       {
        if(key==1)
     {  
        delay_ms(10);
        if(key==1) kd=kd+1;
        
       
     }  
    //////////////// 
     if(key==2)
     {  
        delay_ms(10);
        if(key==2)kd=kd-1;
       
        } 
       if(z>=0 && z<=9)kd=b;
       } 
       //////////////////////////////////////////
      if(key==0)c++,b=0;
       
       if(c==4)c=0;
        
       lcd_gotoxy(0,0);
       sprintf(str,"scal=%04d p=%03d i=%03d d=%03d",scal,kp,ki,kd);
        lcd_puts(str);
        
        
       } 
    
     if(q==3)
     { 
        if(key==0)b=0;
       //b=0;
       if(z>=0 && z<=9)irpm=b;
       lcd_gotoxy(0,0);
       sprintf(str,"irpm=%04d                     ",irpm);
        lcd_puts(str);
                
       } 
    
     
  };
}
