/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 27/12/2009
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 1.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/
// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


unsigned char str[40];
long int y,rpm,v,j,p,b,z,key=255,q=0,ki=4,kd=2,kp=4,pwm,scal=450,u,irpm=3500,CurSpd;
unsigned char code[4][4]={{0,4,8,12},{1,5,9,13},{2,6,10,14},{3,7,11,15}};
/////////////////////////////////////////
void PID(void);
// Timer 0 output compare interrupt service routine
/////////////////////////////////////////////////////////cunter  timer 000
interrupt [20] void timer0_comp_isr(void)
{
y++;
}

// Timer 1 overflow interrupt service routine
/////////////////////////////////////////////////////////pwm timer  1111
interrupt [9] void timer1_ovf_isr(void)
{
 TCNT1H=0x00;
 TCNT1L=0x82;
 }
////////////////////////////////////////////////////////////timer 2222
// Timer 2 overflow interrupt service routine
interrupt [5] void timer2_ovf_isr(void)
{ 
    static unsigned char rr;
    rr=TCNT0;
    TCNT2=0x0A;
    TCCR0=0x00; 
    rpm=(y*100+TCNT0)*24/10;
    y=0;      
    TCNT0=0;       
    rr=0;  
    TCCR0=0x0E;
    PID(); 
}

/////////////////////////////////////////////pid

void PID(void)
{
        static long jahat=0,e0=0,e1=0,e2=0,e3=0;
         
        long k=0; 
        CurSpd =rpm;
        e3=e2;
        e2=e1;
        e1=e0;
        e0 =irpm-CurSpd; 
        k=(kp*(e0+e1)+ki*(e0-e1)+(3*(e0-e2)+(e1-e3)*kd))/scal;
      
        pwm = pwm + k;
    
                  
        if(pwm>131)
        {
            if(pwm>254)pwm=253;
            OCR1AL=pwm;
        }
        if(pwm<131)
        { 
              
           jahat=~jahat;
            if(jahat==0)PORTD=0X09;
            if(jahat==1)PORTD=0X06;
            OCR1AL=262-pwm;
        }
       
}

 ///////////////////////////////////////////////key pad///////////////////////

 unsigned char scan_key(void)
{
unsigned char i,data,num_key,temp,p;
num_key=0xff;
temp=0x70;
for(i=0;i<4;i++)
{
PORTA=temp;
delay_ms(2);
data=PINA&0X0F;
delay_ms(10);
data=PINA&0X0F;
if(data==0x07)num_key=code[0][i];
if(data==0x0b)num_key=code[1][i];
if(data==0x0d)num_key=code[2][i];
if(data==0x0e)num_key=code[3][i];
temp=((temp>>1)|0x80)&0xf0;
}
return num_key;
} 
//////////////////////
 void keyin (void)
 {
   if(z>=0 && z<=9)
        {
               delay_ms(100);       
                b=z+b*10; 
           
         }
 }
/////////////
void main(void)
{ 

// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0xf0;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T 
PORTB=0xF0;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x09;
DDRD=0xEF;

// Timer/Counter 0 initialization
// Clock source: T0 pin Rising Edge
// Mode: CTC top=OCR0
// OC0 output: Disconnected
TCCR0=0x0F;
TCNT0=0x00;
OCR0=0x63;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000.000 kHz
// Mode: Fast PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
/*TCCR1A=0x81;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x37;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x3b;
OCR1BH=0x00;
OCR1BL=0x00;*/ 
///////////////////    
TCCR1A=0x81;
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x82;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0xC8;
OCR1BH=0x00;
OCR1BL=0x00; 
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 0.977 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x07;
TCNT2=0x0A;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: On
// INT2 Mode: Rising Edge
//GICR|=0x20;
MCUCR=0x00;
MCUCSR=0x00;
//GIFR=0x20;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x46;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")
PORTD=0X09;
while (1)
      {  
    
     key=scan_key();
     
     switch(key)
       { 
          case 0 :z=16;
          break;
          case 1 :z=15;
          break;
          case 2 : z=12;
          break;
          case 3 : z=14;
          break;
          case 4 : z=13;
          break;
          case 5 :z=9;
          break;
          case 6 : z=6;
          break;
          case 7 : z=3;
          break;
          case 8 : z=0;
          break;
          case 9 : z=8;
          break;
          case 10 : z=5;
          break;
          case 11 : z=2;
          break;
          case 12 : z=11;
          break;
          case 13 : z=7;
          break;
          case 14 :z=4;
          break;
          case 15 :z=1;
          break;
      }  
      
      delay_ms(5);
     if(key!=0xff)
    { 
       delay_ms(200);
       if(key!=0xff)keyin(); 
     } 
        
    /////////////// /////////////////////////////
     if(key==4)q++;
     if(q==4)q=0;
     if(q==0)
     { 
       lcd_gotoxy(0,0);
       sprintf(str,"pwm=%03d         rpm=%04d     ",OCR1AL,rpm,);
       lcd_puts(str);
     } 
     /////////
      if(q==1)
     { 
        if(key==2) PORTD=0X09;
        if(key==1)PORTD=0X06;
        if(key==3)PORTD=0X05;
        if(PORTD==0X09)
        {
            lcd_gotoxy(0,0);            
            lcd_putsf("chap             ");
        }  
                      
         if(PORTD==0X06)
         {
            lcd_gotoxy(0,0);
            lcd_putsf("rast              ");
         }  
         if(PORTD==0X05)
         {
            lcd_gotoxy(0,0);        
            lcd_putsf("stop               ");
         }                    
         
          if(PINB.1==1)
          {
             lcd_gotoxy(0,1);
             lcd_putsf("ENCOD=rast         ");
          }                    
     
           if(PINB.1==0)
          {
              lcd_gotoxy(0,1);
              lcd_putsf("ENCOD=chap          ");
          }                    
      }
    /////////////////////////
     if(q==2)
     { 
         static unsigned char c=0;
         if(c==0 && z>=0 && z<=9)scal=b;
      //////////////////////////////////////
       if(c==1)
       { 
        if(key==1)
     {  
        delay_ms(10);
        if(key==1) kp=kp+1;
       
     }  
    ///////// 
     if(key==2)
     {  
        delay_ms(10);
        if(key==2) kp=kp-1;
       
     }   
                  
         if( z>=0 && z<=9) kp=b;
           
     }           
       
    //////////////////////////         //////////////
       if(c==2)
       {
         if(key==1)
     {  
        delay_ms(10);
        if(key==1) ki=ki+1;
        
     }  
    ////////
     if(key==2)
     {  
        delay_ms(10);
        if(key==2)ki=ki-1;
        
       }
       
       if(& z>=0 && z<=9)ki=b;
       }
      ////////////////////////////////////////////////////
      
       if(c==3)
       {
        if(key==1)
     {  
        delay_ms(10);
        if(key==1) kd=kd+1;
        
       
     }  
    //////////////// 
     if(key==2)
     {  
        delay_ms(10);
        if(key==2)kd=kd-1;
       
        } 
       if(z>=0 && z<=9)kd=b;
       } 
       //////////////////////////////////////////
      if(key==0)c++,b=0;
       
       if(c==4)c=0;
        
       lcd_gotoxy(0,0);
       sprintf(str,"scal=%04d p=%03d i=%03d d=%03d",scal,kp,ki,kd);
        lcd_puts(str);
        
        
       } 
    
     if(q==3)
     { 
        if(key==0)b=0;
       //b=0;
       if(z>=0 && z<=9)irpm=b;
       lcd_gotoxy(0,0);
       sprintf(str,"irpm=%04d                     ",irpm);
        lcd_puts(str);
                
       } 
    
     
  };
}
